
/**
 * /!\ This file is automatically generated by QLALR from LGCInputLexerIO.g.
 * /!\ Don't edit it!
 */

#include <QRegularExpression>

#include <Qsci/qsciscintilla.h>

#include <ShareablePoints/SPIOException.hpp>
#include <ShareablePoints/ShareableExtraInfos.hpp>
#include <ShareablePoints/ShareableFrame.hpp>
#include <ShareablePoints/ShareableParams.hpp>
#include <ShareablePoints/ShareablePoint.hpp>
#include <ShareablePoints/ShareablePosition.hpp>

#include "tabs/inputs/annotations.hpp"
#include "tabs/inputs/LGCInputLexerIO.hpp"

#define ADDSTYLE(rule, style) ADDSTYLEIDX((rule), style, 1)
#define ADDSTYLEIDX(rule, style, symidx) \
	case (rule): \
		addStyleSym(Styles::style, (symidx)); \
		break

namespace {
inline std::string toTrimmedString(const QString &str, bool utf8)
{
	return toByteArray(str.trimmed(), utf8).constData();
}

inline std::string toTrimmedString(const QStringRef &str, bool utf8)
{
	return toByteArray(str.trimmed().toString(), utf8).constData();
}

inline QString toTrimmedQString(const QStringRef &str)
{
	return str.trimmed().toString();
}
} // namespace

void LGCInputLexerIO::addAnnotation(const QString& annotation)
{
	if(_secondRun && !annotation.isEmpty())
		_infoAnnotation += annotation;
}

void LGCInputLexerIO::addPointAnnotation()
{
	if (_secondRun && !_curTmp.isEmpty() && _ANNOTATION_POINTTYPES.count(_curTmp))
		addAnnotation(_ANNOTATION_POINTTYPES.at(_curTmp));
}

bool LGCInputLexerIO::checkBool(int symidx, const QString &name, Styles style)
{
	const double boo = sym(symidx).toDouble();
	if (boo != 0 && boo != 1)
	{
		QStringList error = {
			name + " must be a boolean value:",
			"0",
			"1"
		};
		throw ParserException(toTrimmedQString(sym(symidx)), error);
	}
	addStyleSym(style, symidx);
	return (bool) boo;
}

int LGCInputLexerIO::checkInt(int symidx, const QString &name, int min, int max, Styles style)
{
	const int sigma = sym(symidx).toInt();
	if (min != max && (sigma < min || sigma > max))
	{
		QStringList error = {name + " must be an integer:"};
		error += ("bigger than " + QString::number(min) + " and (equal or) smaller than " + QString::number(max));
		throw ParserException(toTrimmedQString(sym(symidx)), error);
	}
	addStyleSym(style, symidx);
	return sigma;
}

double LGCInputLexerIO::checkDouble(int symidx, const QString &name, double min, double max, Styles style)
{
	const double sigma = sym(symidx).toDouble();
	if (sigma < min || (min != max && sigma > max))
	{
		QStringList error = {name + " must be a decimal value:"};
		error += "more than " + QString::number(min);
		if (min != max)
			error += "less than " + QString::number(max);
		throw ParserException(toTrimmedQString(sym(symidx)), error);
	}
	addStyleSym(style, symidx);
	return sigma;
}

void LGCInputLexerIO::setOption(const std::string &key, char sep)
{
	if (!lexerMode())
	{
		std::string &option = _curList.getParams().extraInfos[key];
		if (!option.empty())
			option += sep;
		option += toTrimmedString(_currentLine, utf8());
	}
}

void LGCInputLexerIO::setInstrument(bool checkTarget)
{
	if (!lexerMode())
		return;

	const QString instr = toTrimmedQString(sym(2));
	_curTmp = instr;
	if (_firstRun)
	{
		if (contains(_measures.instruments, instr))
			reportRepeated("instrument", 2);
		_measures.instruments.emplace(instr, LGCMeasures::Value{sym(2).position(), instr, instr, _currentLine.toString(), toTrimmedQString(sym(1)), toTrimmedQString(sym(3)), _unusedComment});
	}
	else if (_secondRun && checkTarget)
		jumpTo(_measures.targets, "target", 3, instr + '/' + toTrimmedQString(sym(3)));
	_unusedComment.clear();
}

void LGCInputLexerIO::setTarget()
{
	if (_firstRun)
	{
		QString tgt = toTrimmedQString(sym(1));
		QString tgtid = _curTmp + '/' + tgt;
		if (contains(_measures.targets, tgtid))
			reportRepeated("target", 1);
		_measures.targets.emplace(tgtid, LGCMeasures::Value{sym(1).position(), tgtid, tgt, _currentLine.toString(), "", _curTmp, _unusedComment});
	}
	_unusedComment.clear();
}

void LGCInputLexerIO::setMeasure(const QString &measureName)
{
	if (_firstRun)
	{
		QString distinction = _curTmp.isEmpty() && !_curTmpFrame.isEmpty() ? _curTmpFrame.remove(0, _curTmpFrame.lastIndexOf('/') + 1) : _curTmp;
		QString msrid = distinction + '/' + measureName;
		QString msrtype;
		int i = 0;
		
		while (contains(_measures.measures, msrid + '/' + QString::number(i)))
			i++;
		msrid += '/' + QString::number(i);
		if (contains(_measures.instruments, _curTmp))
			msrtype = _measures.instruments.at(_curTmp).type;
		_measures.measures.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, measureName, _currentLine.toString(), msrtype, _curTmp, _unusedComment});
	}
	_unusedComment.clear();
}

void LGCInputLexerIO::setPoint(const QString &type)
{
	QString point = toTrimmedQString(sym(1));
	if (_firstRun && type != "*PDOR")
	{
		std::unordered_map<QString, int> counter = {};
		if (contains(_measures.points, point))
			reportRepeated("point", 1);
		else if (_missingPointObservations.find(point) != std::cend(_missingPointObservations))
		{
			counter = _missingPointObservations.at(point);
			_missingPointObservations.erase(point);
		}
		_measures.points.emplace(point, LGCMeasures::Value{sym(1).position(), point, point, _currentLine.toString(), type, "", _unusedComment, counter});
	}
	else if (_secondRun && type == "*PDOR")
	{
		jumpTo(_measures.points, "point");

		_measures.points[point].others = type;
	}
	else if (!lexerMode() && type != "*PDOR")
	{
		double x = sym(2).toDouble();
		double y = sym(3).toDouble();
		double z = sym(4).toDouble();
		ShareablePosition pos{};
		if (type == "*CALA")
			pos = {x, y, z, 0, 0, 0, false, false, false};
		else if (type == "*POIN")
			pos = {x, y, z, 0, 0, 0, true, true, true};
		else if (type == "*VXY")
			pos = {x, y, z, 0, 0, 0, true, true, false};
		else if (type == "*VXZ")
			pos = {x, y, z, 0, 0, 0, true, false, true};
		else if (type == "*VYZ")
			pos = {x, y, z, 0, 0, 0, false, true, true};
		else if (type == "*VZ")
			pos = {x, y, z, 0, 0, 0, false, false, true};

		// inline comment
		QStringRef line = _currentLine, id, dcum;
		int commentpos = -1;
		for (const auto &c : commentChars())
		{
			if (line.contains(c))
			{
				commentpos = line.indexOf(c);
				break;
			}
		}
		// functional comment
		if (line.contains(_functionalComment))
			commentpos = line.indexOf(_functionalComment);
		if (commentpos < 0)
			line.clear();
		else
		{
			if (line[commentpos] != '$')
				line = line.mid(commentpos + 1).trimmed();
			else
			{
				line = line.mid(commentpos + 1).trimmed();
				const auto &split = line.split(' ',
#if (QT_VERSION < QT_VERSION_CHECK(5, 14, 0))
					QString::SplitBehavior::SkipEmptyParts
#else
					Qt::SplitBehaviorFlags::SkipEmptyParts
#endif
				);
				if (split.size() >= 2)
				{
					dcum = split[0];
					id = split[1];
					if (split.size() > 3)
						line = line.mid(split[2].position());
					else
						line.clear();
				}
			}
		}
		
		ShareableExtraInfos infos = {{"lgcType", toByteArray(type, utf8()).constData()}};
		if (!id.isEmpty())
			infos.addExtraInfo("id", toByteArray(id.toString(), utf8()).constData());
		if (!dcum.isEmpty())
			infos.addExtraInfo("DCUM", toByteArray(dcum.toString(), utf8()).constData());

		_curFrame->add(new ShareablePoint{
			toByteArray(point, utf8()).constData(),
			pos,
			toByteArray(line.toString(), utf8()).constData(),
			toByteArray(_unusedComment, utf8()).constData(),
			true,
			infos
		});
	}
	_unusedComment.clear();
}

void LGCInputLexerIO::setFrame(const QString &frameName)
{
	if (_firstRun)
	{
		if (contains(_measures.frames, frameName))
			reportRepeated("frame", 1);
		_measures.frames.emplace(frameName, LGCMeasures::Value{sym(0).position(), frameName, frameName, _currentLine.toString(), toTrimmedQString(sym(0)), "", _unusedComment});	}
	else if (!lexerMode())
	{
		ShareablePosition &translation = _curFrame->getTranslation();
		ShareablePosition &rotation = _curFrame->getRotation();
		
		// Frame position
		translation.x = sym(2).toDouble();
		translation.y = sym(3).toDouble();
		translation.z = sym(4).toDouble();
		rotation.x = sym(5).toDouble();
		rotation.y = sym(6).toDouble();
		rotation.z = sym(7).toDouble();
		_curFrame->setScale(sym(8).toDouble());
		
		QStringRef line = _currentLine, id, dcum;
		// Frame freedom
		// translation
		if (line.contains(LGCInputLexerIO::spell[LGCInputLexerIO::TX]))
			translation.isfreex = true;
		if (line.contains(LGCInputLexerIO::spell[LGCInputLexerIO::TY]))
			translation.isfreey = true;
		if (line.contains(LGCInputLexerIO::spell[LGCInputLexerIO::TZ]))
			translation.isfreez = true;
		// rotation
		if (line.contains(LGCInputLexerIO::spell[LGCInputLexerIO::RX]))
			rotation.isfreex = true;
		if (line.contains(LGCInputLexerIO::spell[LGCInputLexerIO::RY]))
			rotation.isfreey = true;
		if (line.contains(LGCInputLexerIO::spell[LGCInputLexerIO::RZ]))
			rotation.isfreez = true;
		// scale
		if (line.contains(LGCInputLexerIO::spell[LGCInputLexerIO::SCL]))
			_curFrame->isFreeScale(true);
	}
}

void LGCInputLexerIO::jumpTo(const LGCMeasures::MeasureMap &map, const QString &type, int idx, QString key)
{
	if (_secondRun)
	{
		QString name = toTrimmedQString(sym(idx));
		if (key.isEmpty())
			key = name;
		if (!contains(map, key))
			throw ParserException(name, {key + ' ' + type + " is not defined"});
		addIndicationSym(TextIndicator::INTERNAL, idx, map.at(key).position);
	}
}

void LGCInputLexerIO::countMeasure(const QString &type, int pointSymbolIdx)
{
	if (_firstRun)
	{
		QString pointname = toTrimmedQString(sym(pointSymbolIdx));
		std::unordered_map<QString, int> *usedMap;

		if (!contains(_measures.points, pointname))
			usedMap = &_missingPointObservations[pointname];
		else
			usedMap = &_measures.points.at(pointname).counter;

		if (type == "CAMUVEC")
			usedMap->operator[](type + " (/2)") += 2;
		else if (type == "CAMUVD" || type == "OBSXYZ")
			usedMap->operator[](type + " (/3)") += 3;
		else if (type == "TSTNPLR3D")
		{
			usedMap->operator[]("TSTNANGL")++;
			usedMap->operator[]("TSTNZEND")++;
			usedMap->operator[]("TSTNDIST")++;
		}
		else
			usedMap->operator[](type) += 1;

		if (!_curPointMeasure.isEmpty() && contains(_measures.points, _curPointMeasure))
			_measures.points.at(_curPointMeasure).counter[type]++;
	}
}

void LGCInputLexerIO::showMeasure(const QString &type, const QString &point, int idx)
{
	auto addMeasureMarker = [this, idx](TextMarker marker, const QString &errortype, int nbobs) -> void {
		const int pos = sym(idx).position();
		int line, index;
		editor()->lineIndexFromPosition(pos, &line, &index);
		const std::bitset<32> markers = editor()->markersAtLine(line);

		if (marker == TextMarker::ERROR
			|| (marker == TextMarker::WARNING && !markers[TextMarker::ERROR])
			|| (!markers[TextMarker::ERROR] && !markers[TextMarker::WARNING]))
			addMarker(editor(), pos, marker);

		static const QString statusstring = tr(R"""(<h1 style="color: %1;">%2</h1>
			<p style="color: %1;">Not enough observations for this type of point: %3.</p>)""");
		if (marker == TextMarker::INFO)
			_infoAnnotation += statusstring.arg("blue").arg(errortype, QString::number(nbobs));
		else
			_errorAnnotation += statusstring.arg("red").arg(errortype, QString::number(nbobs));
	};

	int count = _measures.points[point].totalCount();
	if (type == "*POIN" && count < 3)
			addMeasureMarker(TextMarker::WARNING, "Warning", count);
	else if ((type == "*VXY" || type == "*VXZ" || type == "*VYZ") && count < 2)
			addMeasureMarker(TextMarker::WARNING, "Warning", count);
	else if (type == "*VZ" && count < 1)
			addMeasureMarker(TextMarker::WARNING, "Warning", count);
}

void LGCInputLexerIO::reportRepeated(const QString &type, int idx)
{
	// Marker should be added automatically on throw in LexerParser but since Input does parsing twice it has to be handled manually
	addMarker(editor(), sym(idx).position(), TextMarker::ERROR);
	throw ParserException(toTrimmedQString(sym(idx)), {toTrimmedQString(sym(idx)) + ' ' + type + " already exists"});
}

bool LGCInputLexerIO::isRootFrame(const std::string &name) const
{
	return name == "ROOT";
}

void LGCInputLexerIO::consumeRule(int rule)
{
	switch(rule)
	{

	ADDSTYLE(4, Comment);
 case 5: 
	case 6: // POINTNAMEDEF
		addStyleSym(Styles::FunctionalComment, 1);
		break;
 case 7: 
	case 8: // POINTNAMEDEF
		addStyleSym(Styles::FunctionalComment, 1);
		break;
 case 14: 
	case 15: // POINTNAMEDEF
		addStyleSym(Styles::PointName, 1);
		if (_secondRun && _curTmp != "*PDOR")
		{
			addIndicationSym(TextIndicator::HOVERONLY);
			showMeasure(_curTmp, toTrimmedQString(sym(1)));
		}
		break;
 case 16: 
	case 17: // POINTNAME
		addStyleSym(Styles::PointName, 1);
		jumpTo(_measures.points, "point");
		break;

	ADDSTYLE(18, InstrumentName);

	case 19:
		addStyleSym(Styles::InstrumentName, 1);
		jumpTo(_measures.instruments, "instrument");
		break;

	ADDSTYLE(20, TargetName);
 case 21: 
	case 22: // MSRIDTEXT
		addStyleSym(Styles::Normal, 1);
		break;

	case 23:
		addStyleSym(Styles::FrameName, 1);
		_curTmp = toTrimmedQString(sym(1));
		if (!isRootFrame(_curTmp.toStdString())) // Since ROOT frame isn't defined linking it to the definition is skipped
			jumpTo(_measures.frames, "frame");
		break;
 case 24:  case 25:  case 26:  case 27:  case 28:  case 29: 
	case 30:
		addStyleSym(Styles::FrameParameter, 1);
		break;

	case 41:
		if (!lexerMode())
			_curList.setTitle(_curList.getTitle() + '\n');
		break;

	// *TITR
	case 42:
		addAnnotation(_ANNOTATION_TITR);
		addStyleSym(Styles::StartEnd, 1);
		break;

	case 43:
		addAnnotation(_ANNOTATION_TITR);

	case 44:
		addStyleSym(Styles::Normal, 1);
		if (!lexerMode())
			_curList.setTitle(_curList.getTitle() + toTrimmedString(sym(1), utf8()));
		break;
 case 45: 
	case 46:
		addStyleSym(Styles::Normal, 2);
		if (!lexerMode())
			_curList.setTitle(_curList.getTitle() + toTrimmedString(sym(2), utf8()));
		break;

	case 47:
		endFolding();
		break;
 case 55:  case 56:  case 57: 
	case 58: // Datum Option
		addAnnotation(_ANNOTATION_DATUMOPTIONS);
		addStyleSym(Styles::DatumOption, 1);
		startFolding();
		if (!lexerMode())
		{
			_curList.getParams().coordsys = toTrimmedString(sym(1), utf8()) == "*OLOC" ? ShareableParams::ECoordSys::k3DCartesian : ShareableParams::ECoordSys::k2DPlusH;
			setOption("coordinateSystem");
		}
		break;
 
	case 61: 
		addAnnotation(_ANNOTATION_ALLFIXED);
		addStyleSym(Styles::CalculationOption, 1);

		setOption("CalculationOptions");
		break;

	case 63: // SIMU 1 param
		checkInt(2, "Number of Simulations or Seed Value");

		setOption("CalculationOptions");
		break;
 case 64: 
	case 65: // SIMU 2 params
		checkInt(2, "Number of Simulations");
		checkInt(3, "Seed Value");

		setOption("CalculationOptions");
		break;

	// *SIMU
	case 66:
		addAnnotation(_ANNOTATION_SIMU);
		addStyleSym(Styles::CalculationOption, 1);
		break;

	case 67:
		addStyleSym(Styles::Comment, 1);
		break;

	case 68:
		addStyleSym(Styles::Comment, 2);
		break;

	case 74: 
		addAnnotation(_ANNOTATION_APRI);
		addStyleSym(Styles::OutputOption, 1);

		setOption("OutputOptions");
		break;

	case 75: 
		addAnnotation(_ANNOTATION_CHABA);
		addStyleSym(Styles::OutputOption, 1);

		setOption("OutputOptions");
		break;

	case 76: 
		addAnnotation(_ANNOTATION_COVAR);
		addStyleSym(Styles::OutputOption, 1);

		setOption("OutputOptions");
		break;

	case 77: 
		addAnnotation(_ANNOTATION_DEFA);
		addStyleSym(Styles::OutputOption, 1);

		setOption("OutputOptions");
		break;

	case 78: 
		addAnnotation(_ANNOTATION_HIST);
		addStyleSym(Styles::OutputOption, 1);

		setOption("OutputOptions");
		break;

	case 79: 
		addAnnotation(_ANNOTATION_NODUP);
		addStyleSym(Styles::OutputOption, 1);

		setOption("OutputOptions");
		break;

	case 80: 
		addAnnotation(_ANNOTATION_PRES);
		addStyleSym(Styles::OutputOption, 1);

		setOption("OutputOptions");
		break;

	case 81: // Simple options
		addAnnotation(_ANNOTATION_SOBS);
		addStyleSym(Styles::OutputOption, 1);

		setOption("OutputOptions");
		break;
 case 82: 
	case 83:
		endFolding();
		break;

	case 93: // CONSI
		addAnnotation(_ANNOTATION_CONSI);
		addStyleSym(Styles::OutputOption, 1);
		_inlineContexts.insert(InlineCxt::CONSI);

		//setOption("OutputOptions");
		break;

	case 94: // LIBR
	addStyleSym(Styles::OptionParameter, 1);
	break;
 case 97:  case 98:  case 99:  case 100:  case 101:  case 102: 
	case 103:
	addStyleSym(Styles::OptionParameter, 1);
	break;

	case 106: // EREL
		addAnnotation(_ANNOTATION_EREL);
		addStyleSym(Styles::OutputOption, 1);

		setOption("OutputOptions");
		startFolding();
		break;
 case 107: 
	case 108:
		addAnnotation(_ANNOTATION_EREL);

		setOption("OutputOptions");
		break;

	case 111: // ERELFRAME
		addAnnotation(_ANNOTATION_ERELFRAME);
		addStyleSym(Styles::OutputOption, 1);

		setOption("OutputOptions");
		startFolding();
		break;

	case 112:
		addAnnotation(_ANNOTATION_ERELFRAME);
		setOption("OutputOptions");
		break;

	case 115: // FAUT
		addAnnotation(_ANNOTATION_FAUT);
		addStyleSym(Styles::OutputOption, 1);

		setOption("OutputOptions");
		break;

	case 116:
		checkDouble(1, "alpha", 0, 1);
		checkDouble(2, "beta", 0, 1);
		break;

	case 119: // FMTPCOL
		addAnnotation(_ANNOTATION_FMTP);
		addStyleSym(Styles::OptionParameter, 2);
		break;

	case 120: // FMTPSEP WORD
	{
		addAnnotation(_ANNOTATION_FMTP);
		addStyleSym(Styles::OptionParameter, 2);
		QStringRef sep = sym(3).trimmed();
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::Normal, 4);
		addStyleSym(Styles::Normal, 5);
		break;
	}

	case 121: // *FMTP
		addStyleSym(Styles::OutputOption, 1);
		_inlineContexts.insert(InlineCxt::FMTP);

		setOption("OutputOptions");
		break;

	case 124:
		addAnnotation(_ANNOTATION_JSON);
		addStyleSym(Styles::OutputOption, 1);
		_inlineContexts.insert(InlineCxt::JSON);

		setOption("OutputOptions");
		break;

	case 126:
		addStyleSym(Styles::OutputOption, 1);
		break;

	case 128:
	{
		int prec = checkInt(2, "precision", 0, 7);
		if (!lexerMode())
			_curList.getParams().precision = prec;
		break;
	}

	case 129:	// *PREC
	{
		addAnnotation(_ANNOTATION_PREC);
		addStyleSym(CalculationOption, 1);
		break;
	}

	case 132: // *PUNC
		addAnnotation(_ANNOTATION_PUNC);
		addStyleSym(Styles::OutputOption, 1);
		_inlineContexts.insert(InlineCxt::PUNC);

		setOption("OutputOptions");
		break;
 case 133:  case 134:  case 135:  case 136:  case 137:  case 138:  case 139:  case 140:  case 141: 
	case 142: // PUNC parameter
		addStyleSym(Styles::OptionParameter, 1);
		break;
 case 143: 
	case 144:
		endFolding();
		break;

	case 145: // *INSTR
		addAnnotation(_ANNOTATION_INSTR);
		addStyleSym(Styles::StartEnd, 1);
		startFolding();
		_unusedComment.clear();
		break;
 case 148:  case 149:  case 150: 
	case 151:
		endFolding();
		break;

	case 157:
		addAnnotation(_ANNOTATION_CAMD);
		addStyleSym(Styles::InstrumentType, 1); // *CAMD
		checkDouble(4, "sigma_instr_centering_mm"); // sigma_instr_centering_mm

		startFolding();
		setInstrument();
		break;

	case 161: // CAMD old
		addAnnotation(_ANNOTATION_CAMD_TGT);
		checkDouble(2, "sigma_X"); // sigma_X
		checkDouble(3, "sigma_Y"); // sigma_Y
		checkDouble(4, "sigma_dist_mm"); // sigma_dist_mm
		checkDouble(5, "sigma_tgt_centering_mm"); // sigma_tgt_centering_mm

		setTarget();
		break;

	case 162: // CAMD v2.02
		addAnnotation(_ANNOTATION_CAMD_TGT);
		checkDouble(2, "sigma_X"); // sigma_X
		checkDouble(3, "sigma_Y"); // sigma_Y
		checkDouble(4, "sigma_Z"); // sigma_Z
		checkDouble(5, "sigma_dist_mm"); // sigma_dist_mm
		checkDouble(6, "sigma_tgt_centering_mm"); // sigma_tgt_centering_mm

		setTarget();
		break;

	case 164:
		addAnnotation(_ANNOTATION_EDM);
		addStyleSym(Styles::InstrumentType, 1); // *EDM
		addStyleSym(Styles::Normal, 4); // instr_height_m
		checkDouble(5, "sigma_instr_height_mm"); // sigma_instr_height_mm
		checkDouble(6, "sigma_instr_centering_mm"); // sigma_instr_centering_mm

		startFolding();
		setInstrument();
		break;

	case 168:
		addAnnotation(_ANNOTATION_EDM_TGT);
		checkDouble(2, "sigma_dist_mm"); // sigma_dist_mm
		addStyleSym(Styles::Normal, 3); // ppm_mm
		checkBool(4, "dCorr_adjustable"); // dCorr_adjustable
		addStyleSym(Styles::Normal, 5); // dCorr_m
		checkDouble(6, "sigma_dCorr_mm"); // sigma_dCorr_mm
		checkDouble(7, "sigma_tgt_centering_mm"); // sigma_tgt_centering_mm
		addStyleSym(Styles::Normal, 8); // tgt_height_m
		checkDouble(9, "sigma_tgt_height_mm"); // sigma_tgt_height_mm

		setTarget();
		break;

	case 170:
		addAnnotation(_ANNOTATION_LEVEL);
		addStyleSym(Styles::InstrumentType, 1); // *LEVEL
		checkBool(4, "collimationAngle_adjustable"); // collimationAngle_adjustable
		addStyleSym(Styles::Normal, 5); // collimationAngle_gon

		startFolding();
		setInstrument();
		break;

	case 174:
		addAnnotation(_ANNOTATION_LEVEL_TGT);
		checkDouble(2, "sigma_dist_mm"); // sigma_dist_mm
		addStyleSym(Styles::Normal, 3); // ppm_mm
		addStyleSym(Styles::Normal, 4); // dCorr_m
		checkDouble(5, "sigma_dCorr_mm"); // sigma_dCorr_mm
		addStyleSym(Styles::Normal, 6); // vert_offset_m
		addStyleSym(Styles::Normal, 7); // sigma_offset_mm

		setTarget();
		break;

	case 176:
		addAnnotation(_ANNOTATION_POLAR);
		addStyleSym(Styles::InstrumentType, 1); // *POLAR
		addStyleSym(Styles::Normal, 4); // instr_height_m
		checkDouble(5, "sigma_instr_height_mm"); // sigma_instr_height_mm
		checkDouble(6, "sigma_instr_centering_mm"); // sigma_instr_centering_mm
		addStyleSym(Styles::Normal, 7); // const_angl_gon

		startFolding();
		setInstrument();
		break;

	case 180:
		addAnnotation(_ANNOTATION_POLAR_TGT);
		checkDouble(2, "sigma_ANGL_cc"); // sigma_ANGL_cc
		checkDouble(3, "sigma_ZEND_cc"); // sigma_ZEND_cc
		checkDouble(4, "sigma_DIST_mm"); // sigma_DIST_mm
		addStyleSym(Styles::Normal, 5); // ppm_mm
		checkBool(6, "dCorr_adjustable"); // dCorr_adjustable
		addStyleSym(Styles::Normal, 7); // dCorr_m
		checkDouble(8, "sigma_dCorr_mm"); // sigma_dCorr_mm
		checkDouble(9, "sigma_tgt_centering_mm"); // sigma_tgt_centering_mm
		addStyleSym(Styles::Normal, 10); // tgt_height_m
		checkDouble(11, "sigma_tgt_height_mm"); // sigma_tgt_height_mm

		setTarget();
		break;

	case 182:
		addAnnotation(_ANNOTATION_SCALE);
		addStyleSym(Styles::InstrumentType, 1); // *SCALE
		checkDouble(3, "sigma_dist_mm"); // sigma_dist_mm
		addStyleSym(Styles::Normal, 4); // ppm_mm
		addStyleSym(Styles::Normal, 5); // dCorr_m
		checkDouble(6, "sigma_dCorr_mm"); // sigma_dCorr_mm
		checkDouble(7, "sigma_instr_centering_mm"); // sigma_instr_centering_mm

		setInstrument(false);
		break;

	case 184:
		addAnnotation(_ANNOTATION_INCL);
		addStyleSym(Styles::InstrumentType, 1); // instr_ID
		addStyleSym(Styles::Normal, 3); // sigma_angle_cc
		addStyleSym(Styles::Normal, 4); // sigma_ppm  
		addStyleSym(Styles::Normal, 5); // aCorr_gon
		addStyleSym(Styles::Normal, 6); // sigma_aCorr_cc
		addStyleSym(Styles::Normal, 7); // refAngle_gon
		addStyleSym(Styles::Normal, 8); // sigma_refAngle_cc

		setInstrument(false);
		break;

	case 186:
		addAnnotation(_ANNOTATION_HLSR);
		addStyleSym(Styles::InstrumentType, 1); // *HLSR
		checkDouble(3, "sigma_dist_mm"); // sigma_dist_mm
		addStyleSym(Styles::Normal, 4); // sigma_instr_height_mm
		addStyleSym(Styles::Normal, 5); // sigma_instr_centering_mm

		setInstrument(false);
		break;

	case 188:
		addAnnotation(_ANNOTATION_WPSR);
		addStyleSym(Styles::InstrumentType, 1); // *WPSR
		checkDouble(3, "sigma_dist_X_mm"); // sigma_dist_X_mm
		checkDouble(4, "sigma_dist_Z_mm"); // sigma_dist_Z_mm
		addStyleSym(Styles::Normal, 5); // sigma_instr_centering_X_mm
		addStyleSym(Styles::Normal, 6); // sigma_instr_centering_Z_mm

		setInstrument(false);
		break;
 case 197:  case 198: 
	case 199:
		_curTmp = toTrimmedQString(sym(1));
		if(!lexerMode())
		{
			_curFrame->add(new ShareableFrame(_curList.getParamsPointer(), _curTmp.toStdString()));
			_curFrame = &_curFrame->getFrame(_curFrame->sizeFrames() - 1);		
		}
		setFrame(_curTmp);
		_curTmpFrame.append('/' + _curTmp);
		break;

	case 203:
		addStyleSym(Styles::Frame, 1);
		addStyleSym(Styles::FrameName, 2);
		break;

	case 204:
		addAnnotation(_ANNOTATION_FRAME);
		addStyleSym(Styles::Frame, 1); // FRAMESTART
		_inlineContexts.insert(InlineCxt::FRAMESTART);
		startFolding();
		break;

	case 205:
		addAnnotation(_ANNOTATION_FRAME);
		addStyleSym(Styles::Frame, 1); // FRAMEEND
		// Take the most nested Frame name to escape it first
		if (_curTmpFrame.contains('/'))
		{
			if(_secondRun)
				jumpTo(_measures.frames, "", 1, _curTmpFrame.right(_curTmpFrame.size() - _curTmpFrame.lastIndexOf('/') - 1));
			_curTmpFrame = _curTmpFrame.left(_curTmpFrame.lastIndexOf('/'));
		}
		// if not empty and does not contain /, then it is the outermost frame
		else if (!_curTmpFrame.isEmpty())
			_curTmpFrame = "";
		if(!lexerMode())
			_curFrame = _curFrame->getParentFrame();
		
		endFolding();
		break;

	case 206:
		_curTmp.clear();
		endFolding();
		break;
 case 207: 
	case 208: // Point type
		addAnnotation(_ANNOTATION_POINTS);
		addStyleSym(Styles::PointType, 1);
		_curTmp = toTrimmedQString(sym(1));
		startFolding();
		_unusedComment.clear();
		break;
 case 209:  case 210:  case 211: 
	case 212:
		endFolding();
		_curTmp.clear();
		_curTmp2.clear();
		_curPointMeasure.clear();
		break;
 case 213: 
	case 214:
		if (!_contexts.empty())
			_contexts.pop_back();
		break;
 case 217:  case 218: 
	case 219:
		endFolding();
		break;

	case 223:
		_curTmp.clear();
		endFolding();
		break;
 case 224:  case 225:  case 226:  case 227:  case 228: 
	case 229: // Point type
		addAnnotation(_ANNOTATION_POINTS);
		addStyleSym(Styles::PointType, 1);
		_curTmp = toTrimmedQString(sym(1));
		startFolding();
		_unusedComment.clear();
		break;

	case 236: // PointDef
		addPointAnnotation();
		addStyleSym(Styles::PointCoord, 2);
		addStyleSym(Styles::PointCoord, 3);
		addStyleSym(Styles::PointCoord, 4);
		setPoint(_curTmp);
		break;

	case 237:
		endFolding();
		_curTmp.clear();
		_unusedComment.clear();
		break;

	case 238: // PDOR
		addAnnotation(_ANNOTATION_PDOR);
		addStyleSym(Styles::PointType, 1);
		_curTmp = toTrimmedQString(sym(1));
		startFolding();
		break;
 case 239: 
	case 240: // PdorParam
		addAnnotation(_ANNOTATION_PDOR);
		addStyleSym(Styles::PointName, 1);
		setPoint(_curTmp);
		break;

	case 242: // PdorParam
		addStyleSym(Styles::Normal, 2);
		break;
 case 243:  case 244:  case 245:  case 246:  case 247:  case 248:  case 249: 
	case 250:
		endFolding();
		_curTmp.clear();
		_curTmp2.clear();
		_curPointMeasure.clear();
		break;

	case 251: // AC default_angle_gon
		addStyleSym(Styles::MeasureParameter, 1);
		addStyleSym(Styles::Normal, 2);
		break;

	case 252: // ACSE default_angle_cc
		addStyleSym(Styles::MeasureParameter, 1);
		addStyleSym(Styles::Normal, 2);
		break;

	case 253: // ACST constant_angle_gons
		addStyleSym(Styles::MeasureParameter, 1);
		addStyleSym(Styles::Normal, 2);
		break;

	case 254: // ASE sigma_ANGL_cc
		addStyleSym(Styles::MeasureParameter, 1);
		checkDouble(2, "sigma_ANGL_cc");
		break;

	case 255: // CST constant_angle
		addStyleSym(Styles::MeasureParameter, 1);
		addStyleSym(Styles::Normal, 2);
		break;

	case 256: // DCOR correction_m
		addStyleSym(Styles::MeasureParameter, 1);
		addStyleSym(Styles::Normal, 2);
		break;

	case 257: // DHOR dist_m  DSE sigma_dist_mm
		addStyleSym(Styles::MeasureParameter, 1);
		addStyleSym(Styles::Normal, 2);
		break;

	case 258: // DSE sigma_dist_mm
		addStyleSym(Styles::MeasureParameter, 1);
		checkDouble(2, "sigma_dist_mm");
		break;

	case 259: // ICSE  sigma_instr_centering_mm
		addStyleSym(Styles::MeasureParameter, 1);
		checkDouble(2, "sigma_instr_centering_mm");
		break;

	case 260: // IH instr_heigth_m
		addStyleSym(Styles::MeasureParameter, 1);
		addStyleSym(Styles::Normal, 2);
		break;

	// IHFIX
	ADDSTYLE(261, MeasureParameter);

	case 262: // IHSE sigma_instr_height_mm
		addStyleSym(Styles::MeasureParameter, 1);
		checkDouble(2, "sigma_instr_height_mm");
		break;

	case 263: // INSTR incl_instr_ID
		addStyleSym(Styles::MeasureParameter, 1);
		break;

	case 264: // PPM ppm_mm
		addStyleSym(Styles::MeasureParameter, 1);
		addStyleSym(Styles::Normal, 2);
		break;

	case 265: // PtLine point_on_line
		addStyleSym(Styles::MeasureParameter, 1);
		break;

	case 266: // RefPt reference_point
		addStyleSym(Styles::MeasureParameter, 1);
		_curPointMeasure = toTrimmedQString(sym(2));
		break;

	case 267: // AC default_angle_gon
		addStyleSym(Styles::MeasureParameter, 1);
		addStyleSym(Styles::Normal, 2);
		break;

	case 268: // AC default_angle_cc
		addStyleSym(Styles::MeasureParameter, 1);
		addStyleSym(Styles::Normal, 2);
		break;

	// ROT3D
	ADDSTYLE(269, MeasureParameter);

	// SAGFIX
	ADDSTYLE(270, MeasureParameter);

	case 271: // SAGSE sigma_sag_mm
		addStyleSym(Styles::MeasureParameter, 1);
		checkDouble(2, "sigma_sag_mm");
		break;

	case 272: // SCALE scale_instr_ID
		addStyleSym(Styles::MeasureParameter, 1);
		break;

	case 273: // TCSE sigma_tgt_centering_mm
		addStyleSym(Styles::MeasureParameter, 1);
		checkDouble(2, "sigma_mm");
		break;

	case 274: // TH tgt_height_m
		addStyleSym(Styles::MeasureParameter, 1);
		addStyleSym(Styles::Normal, 2);
		break;

	case 275: // THSE sigma_tgt_height_mm
		addStyleSym(Styles::MeasureParameter, 1);
		checkDouble(2, "sigma_mm");
		break;

	case 276: // TRGT changed_tgt_ID
		addStyleSym(Styles::MeasureParameter, 1);

		jumpTo(_measures.targets, "target", 2, _curTmp + '/' + toTrimmedQString(sym(2)));
		break;

	case 277: // OBSE sigma_cc_mm
		addStyleSym(Styles::MeasureParameter, 1);
		checkDouble(2, "sigma_mm");
		break;

	case 278: // XICSE sigma_instr_centering_X_mm
		addStyleSym(Styles::MeasureParameter, 1);
		checkDouble(2, "sigma_instr_centering_X_mm");
		break;

	case 279: // XSE sigma_x
		addStyleSym(Styles::MeasureParameter, 1);
		checkDouble(2, "sigma_mm");
		break;

	case 280: // YSE sigma_y
		addStyleSym(Styles::MeasureParameter, 1);
		checkDouble(2, "sigma_mm");
		break;

	case 281: // ZICSE sigma_instr_centering_Z_mm
		addStyleSym(Styles::MeasureParameter, 1);
		checkDouble(2, "sigma_instr_centering_Z_mm");
		break;

	case 282: // ZSE sigma_z
		addStyleSym(Styles::MeasureParameter, 1);
		checkDouble(2, "sigma_mm");
		break;

	case 283: // WSSE sigma_water_surface_mm
		addStyleSym(Styles::MeasureParameter, 1);
		checkDouble(2, "sigma_water_surface_mm");
		break;

	case 284: // WIID wire_ID
		addStyleSym(Styles::MeasureParameter, 1);
		addStyleSym(Styles::PointName, 2);
		// fake point to link to
		_measures.points.emplace(sym(2).toString().trimmed(),
			LGCMeasures::Value{sym(2).position(), sym(2).toString().trimmed(), sym(2).toString(), _currentLine.toString(), "", "", ""});
		break;

	case 285: // WSID water_ID
		addStyleSym(Styles::MeasureParameter, 1);
		addStyleSym(Styles::PointName, 2);
		// fake point to link to
		_measures.points.emplace(sym(2).toString().trimmed(),
			LGCMeasures::Value{sym(2).position(), sym(2).toString().trimmed(), sym(2).toString(), _currentLine.toString(), "", "", ""});
		break;

	case 286: // ID observationID
		addStyleSym(Styles::MeasureParameter, 1);
		break;
 case 287: 
	case 288:
		if (!_contexts.empty())
			_contexts.pop_back();
		break;

	case 291: // *CAM cam_position instr_ID
		addAnnotation(_ANNOTATION_CAM);
		addStyleSym(Styles::MeasureType, 1);
		_contexts.push_back(Context::MEASURES);

		startFolding();
		_curTmp = toTrimmedQString(sym(3));
		_curPointMeasure = toTrimmedQString(sym(2));
		break;
 case 298: 
	case 299:
		endFolding();
		break;

	case 304: // *UVD
		addAnnotation(_ANNOTATION_UVD);
		addStyleSym(Styles::MeasureType, 1);
		startFolding();
		break;

	case 311: // point obs_x obs_y z_comp obs_dist_m
		addAnnotation(_ANNOTATION_UVD_POINT);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::Normal, 4);
		addStyleSym(Styles::Normal, 5);

		setMeasure("CAMUVD/" + toTrimmedQString(sym(1)));
		countMeasure("CAMUVD");
		break;

	case 324: // *UVEC
		addAnnotation(_ANNOTATION_UVEC);
		addStyleSym(Styles::MeasureType, 1);
		startFolding();
		break;

	case 331: // point obs_x obs_y z_comp
		addAnnotation(_ANNOTATION_UVEC_POINT);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::Normal, 4);

		setMeasure("CAMUVEC/" + toTrimmedQString(sym(1)));
		countMeasure("CAMUVEC");
		break;
 case 340: 
	case 341:
		if (!_contexts.empty())
			_contexts.pop_back();
		break;

	case 344: // *DSPT stn instr_ID
		addAnnotation(_ANNOTATION_DSPT);
		addStyleSym(Styles::MeasureType, 1);
		_contexts.push_back(Context::MEASURES);

		startFolding();
		_curTmp = toTrimmedQString(sym(3));
		_curPointMeasure = toTrimmedQString(sym(2));
		break;

	case 358: // point obs_dist_m
		addAnnotation(_ANNOTATION_DSPT_POINT);
		addStyleSym(Styles::Normal, 2);

		setMeasure("DSPT/" + toTrimmedQString(sym(1)));
		countMeasure("DSPT");
		if (_secondRun && editor())
		{
			int line = -1, pos = -1;
			editor()->lineIndexFromPosition(sym(1).position(), &line, &pos);
			_sigmaLines[line].insert("OBSE");
		}
		break;
 case 369: 
	case 370:
		if (!_contexts.empty())
			_contexts.pop_back();
		break;

	case 373: // *DLEV instr_ID
		addAnnotation(_ANNOTATION_DLEV);
		addStyleSym(Styles::MeasureType, 1);
		_contexts.push_back(Context::MEASURES);

		startFolding();
		_curTmp = toTrimmedQString(sym(2));
		break;

	case 380: // point obs_m
		addAnnotation(_ANNOTATION_DLEV_POINT);
		addStyleSym(Styles::Normal, 2);

		setMeasure("DLEV/" + toTrimmedQString(sym(1)));
		countMeasure("DLEV");
		if (_secondRun && editor())
		{
			int line = -1, pos = -1;
			editor()->lineIndexFromPosition(sym(1).position(), &line, &pos);
			_sigmaLines[line].insert("OBSE");
		}
		break;
 case 392: 
	case 393:
		if (!_contexts.empty())
			_contexts.pop_back();
		break;

	case 396: // *ORIE stn_point POLAR_ID
		addAnnotation(_ANNOTATION_ORIE);
		addStyleSym(Styles::MeasureType, 1);
		_contexts.push_back(Context::MEASURES);

		startFolding();
		_curTmp2 = toTrimmedQString(sym(2));
		_curTmp = toTrimmedQString(sym(3));
		_curPointMeasure = _curTmp2;
		break;

	case 408: // point obs_gon
		addAnnotation(_ANNOTATION_ORIE_POINT);
		addStyleSym(Styles::Normal, 2);

		std::swap(_curTmp, _curTmp2);
		setMeasure("ORIE/" + toTrimmedQString(sym(1)));
		std::swap(_curTmp, _curTmp2);
		countMeasure("ORIE");
		if (_secondRun && editor())
		{
			int line = -1, pos = -1;
			editor()->lineIndexFromPosition(sym(1).position(), &line, &pos);
			_sigmaLines[line].insert("OBSE");
		}
		break;
 case 415: 
	case 416:
		if (!_contexts.empty())
			_contexts.pop_back();
		break;

	case 419: // *TSTN stationned_point instr_ID
		addAnnotation(_ANNOTATION_TSTN);
		addStyleSym(Styles::MeasureType, 1);
		_contexts.push_back(Context::MEASURES);

		startFolding();
		_curTmp = toTrimmedQString(sym(3));
		_curPointMeasure = toTrimmedQString(sym(2));
		break;
 case 428: 
	case 429:
		if (_secondRun && editor())
		{
			int line = -1, pos = -1;
			editor()->lineIndexFromPosition(sym(1).position(), &line, &pos);
			_sigmaLines[line].insert("ACST");
		}
		break;

	case 430: // *V0
		addAnnotation(_ANNOTATION_V0);
		addStyleSym(MeasureType, 1);
		break;
 case 437:  case 438:  case 439:  case 440:  case 441:  case 442: 
	case 443:
		endFolding();
		break;

	case 448: // *ANGL
		addAnnotation(_ANNOTATION_ANGL);
		addStyleSym(Styles::MeasureType, 1);
		startFolding();
		break;

	case 455: // point obs_ANGL
		addAnnotation(_ANNOTATION_ANGL_POINT);
		addStyleSym(Styles::Normal, 2);

		setMeasure("TSTNANGL/" + toTrimmedQString(sym(1)));
		countMeasure("TSTNANGL");
		if (_secondRun && editor())
		{
			int line = -1, pos = -1;
			editor()->lineIndexFromPosition(sym(1).position(), &line, &pos);
			_sigmaLines[line].insert("OBSE");
		}
		break;

	case 466: // *DHOR
		addAnnotation(_ANNOTATION_DHOR);
		addStyleSym(Styles::MeasureType, 1);
		startFolding();
		break;

	case 473: // point obs_m
		addAnnotation(_ANNOTATION_DHOR_POINT);
		addStyleSym(Styles::Normal, 2);

		setMeasure("TSTNDHOR/" + toTrimmedQString(sym(1)));
		countMeasure("TSTNDHOR");
		if (_secondRun && editor())
		{
			int line = -1, pos = -1;
			editor()->lineIndexFromPosition(sym(1).position(), &line, &pos);
			_sigmaLines[line].insert("OBSE");
		}
		break;

	case 485: // *DIST
		addAnnotation(_ANNOTATION_DIST);
		addStyleSym(Styles::MeasureType, 1);
		startFolding();
		break;

	case 492: // point obs_dist_m
		addAnnotation(_ANNOTATION_DIST_POINT);
		addStyleSym(Styles::Normal, 2);

		setMeasure("TSTNDIST/" + toTrimmedQString(sym(1)));
		countMeasure("TSTNDIST");
		if (_secondRun && editor())
		{
			int line = -1, pos = -1;
			editor()->lineIndexFromPosition(sym(1).position(), &line, &pos);
			_sigmaLines[line].insert("OBSE");
		}
		break;

	case 505: // *ECDIR hz_angle_gon vert_angle_gon scale_ID
		addAnnotation(_ANNOTATION_ECDIR);
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);

		startFolding();
		break;

	case 512: // point obs_m
		addAnnotation(_ANNOTATION_ECDIR_POINT);
		addStyleSym(Styles::Normal, 2);

		setMeasure("TSTNECDIR/" + toTrimmedQString(sym(1)));
		countMeasure("TSTNECDIR");
		if (_secondRun && editor())
		{
			int line = -1, pos = -1;
			editor()->lineIndexFromPosition(sym(1).position(), &line, &pos);
			_sigmaLines[line].insert("OBSE");
		}
		break;

	case 523: // *ECTH angl_gon scale_ID
		addAnnotation(_ANNOTATION_ECTH);
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::Normal, 2);

		startFolding();
		break;

	case 530: // point obs_m
		addAnnotation(_ANNOTATION_ECTH_POINT);
		addStyleSym(Styles::Normal, 2);

		setMeasure("TSTNECTH/" + toTrimmedQString(sym(1)));
		countMeasure("TSTNECTH");
		if (_secondRun && editor())
		{
			int line = -1, pos = -1;
			editor()->lineIndexFromPosition(sym(1).position(), &line, &pos);
			_sigmaLines[line].insert("OBSE");
		}
		break;

	case 542: // *PLR3D
		addAnnotation(_ANNOTATION_PLR3D);
		addStyleSym(Styles::MeasureType, 1);
		startFolding();
		break;

	case 549: // point obs_ANGL obs_ZEND obs_DIST
		addAnnotation(_ANNOTATION_PLR3D_POINT);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::Normal, 4);

		setMeasure("TSTNPLR3D/" + toTrimmedQString(sym(1)));
		countMeasure("TSTNPLR3D");
		if (_secondRun && editor())
		{
			int line = -1, pos = -1;
			editor()->lineIndexFromPosition(sym(1).position(), &line, &pos);
			_sigmaLines[line].insert({"ASE", "ZSE", "DSE"});
		}
		break;

	case 565: // *ZEND
		addAnnotation(_ANNOTATION_ZEND);
		addStyleSym(Styles::MeasureType, 1);
		startFolding();
		break;

	case 572: // point obs_ZEND
		addAnnotation(_ANNOTATION_ZEND_POINT);
		addStyleSym(Styles::Normal, 2);

		setMeasure("TSTNZEND/" + toTrimmedQString(sym(1)));
		countMeasure("TSTNZEND");
		if (_secondRun && editor())
		{
			int line = -1, pos = -1;
			editor()->lineIndexFromPosition(sym(1).position(), &line, &pos);
			_sigmaLines[line].insert("OBSE");
		}
		break;
 case 584: 
	case 585:
		if (!_contexts.empty())
			_contexts.pop_back();
		break;

	case 587: // *ECHO scale_ID
		addAnnotation(_ANNOTATION_ECHO);
		addStyleSym(Styles::MeasureType, 1);
		_contexts.push_back(Context::MEASURES);

		startFolding();
		break;

	case 594: // stn obs_m
		addAnnotation(_ANNOTATION_ECHO_POINT);
		addStyleSym(Styles::Normal, 2);

		setMeasure("ECHO/" + toTrimmedQString(sym(1)));
		countMeasure("ECHO");
		if (_secondRun && editor())
		{
			int line = -1, pos = -1;
			editor()->lineIndexFromPosition(sym(1).position(), &line, &pos);
			_sigmaLines[line].insert("OBSE");
		}
		break;
 case 602: 
	case 603:
		if (!_contexts.empty())
			_contexts.pop_back();
		break;

	case 606: // *ECVE scale_ID
		addAnnotation(_ANNOTATION_ECVE);
		addStyleSym(Styles::MeasureType, 1);
		_contexts.push_back(Context::MEASURES);

		startFolding();
		break;

	case 613: // point obs_m
		addAnnotation(_ANNOTATION_ECVE_POINT);
		addStyleSym(Styles::Normal, 2);

		setMeasure("ECVE/" + toTrimmedQString(sym(1)));
		countMeasure("ECVE");
		if (_secondRun && editor())
		{
			int line = -1, pos = -1;
			editor()->lineIndexFromPosition(sym(1).position(), &line, &pos);
			_sigmaLines[line].insert("OBSE");
		}
		break;
 case 621: 
	case 622:
		if (!_contexts.empty())
			_contexts.pop_back();
		break;

	case 624: // *ECSP A B scale_ID
		addAnnotation(_ANNOTATION_ECSP);
		addStyleSym(Styles::MeasureType, 1);
		_contexts.push_back(Context::MEASURES);

		startFolding();
		break;

	case 631: // point obs_m
		addAnnotation(_ANNOTATION_ECSP_POINT);
		addStyleSym(Styles::Normal, 2);

		setMeasure("ECSP/" + toTrimmedQString(sym(1)));
		countMeasure("ECSP");
		if (_secondRun && editor())
		{
			int line = -1, pos = -1;
			editor()->lineIndexFromPosition(sym(1).position(), &line, &pos);
			_sigmaLines[line].insert("OBSE");
		}
		break;
 case 640: 
	case 641:
		if (!_contexts.empty())
			_contexts.pop_back();
		break;

	case 643: // *INCLY scale_ID
		addAnnotation(_ANNOTATION_INCLY);
		addStyleSym(Styles::MeasureType, 1);
		_contexts.push_back(Context::MEASURES);

		startFolding();
		break;

	case 650: // point obs_m
		addAnnotation(_ANNOTATION_INCLY);
		addStyleSym(Styles::Normal, 2);
		
		setMeasure("INCLY/" + toTrimmedQString(sym(1)));
		countMeasure("INCLY");
		if (_secondRun && editor())
		{
			int line = -1, pos = -1;
			editor()->lineIndexFromPosition(sym(1).position(), &line, &pos);
			_sigmaLines[line].insert("OBSE");
		}
		break;
 case 662: 
	case 663:
		if (!_contexts.empty())
			_contexts.pop_back();
		break;

	case 666: // *ECWS instr_ID sigma_water_surface_mm
		addAnnotation(_ANNOTATION_ECWS);
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::Normal, 3);
		_contexts.push_back(Context::MEASURES);

		startFolding();
		break;

	case 673: // point obs_m
		addAnnotation(_ANNOTATION_ECWS);
		addStyleSym(Styles::Normal, 2);
		
		setMeasure("ECWS/" + toTrimmedQString(sym(1)));
		countMeasure("ECWS");
		if (_secondRun && editor())
		{
			int line = -1, pos = -1;
			editor()->lineIndexFromPosition(sym(1).position(), &line, &pos);
			_sigmaLines[line].insert("OBSE");
		}
		break;
 case 683: 
	case 684:
		if (!_contexts.empty())
			_contexts.pop_back();
		break;

	case 692: // *ECWI    instr_ID    sag_distance_m    sigma_wire_mm   anchorpoint_1   anchorpoint_2
		addAnnotation(_ANNOTATION_ECWI);
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::Normal, 4);
		_contexts.push_back(Context::MEASURES);

		startFolding();
		break;

	case 699: // stn obs_X_m obs_Z_m
		addAnnotation(_ANNOTATION_ECWI);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		
		setMeasure("ECWI/" + toTrimmedQString(sym(1)));
		countMeasure("ECWI");
		if (_secondRun && editor())
		{
			int line = -1, pos = -1;
			editor()->lineIndexFromPosition(sym(1).position(), &line, &pos);
			_sigmaLines[line].insert({"ZSE"});
		}
		break;
 case 711: 
	case 712:
		if (!_contexts.empty())
			_contexts.pop_back();
		break;

	case 715: // *DVER
		addAnnotation(_ANNOTATION_DVER);
		addStyleSym(Styles::MeasureType, 1);
		startFolding();
		_contexts.push_back(Context::MEASURES);
		break;

	ADDSTYLE(716, MeasureParameter);

	case 723: // point1 point2 obs_m
		addAnnotation(_ANNOTATION_DVER_POINT);
		addStyleSym(Styles::Normal, 3);

		setMeasure("DVER/" + toTrimmedQString(sym(1)) + toTrimmedQString(sym(2)));
		countMeasure("DVER", 1);
		countMeasure("DVER", 2);
		if (_secondRun && editor())
		{
			int line = -1, pos = -1;
			editor()->lineIndexFromPosition(sym(1).position(), &line, &pos);
			_sigmaLines[line].insert("OBSE");
		}
		break;
 case 729: 
	case 730:
		if (!_contexts.empty())
			_contexts.pop_back();
		break;

	case 732: // *OBSXYZ
		addAnnotation(_ANNOTATION_OBSXYZ);
		addStyleSym(Styles::MeasureType, 1);
		startFolding();
		_contexts.push_back(Context::MEASURES);
		break;

	case 739: // point obsX_m obsY_m obsZ_m sigmaX_mm  sigmaY_mm  sigmaZ_mm
		addAnnotation(_ANNOTATION_OBSXYZ_POINT);
		addStyleSym(Styles::PointCoord, 2);
		addStyleSym(Styles::PointCoord, 3);
		addStyleSym(Styles::PointCoord, 4);
		checkDouble(5, "sigmaX_mm");
		checkDouble(6, "sigmaY_mm");
		checkDouble(7, "sigmaZ_mm");

		setMeasure("OBSXYZ/" + toTrimmedQString(sym(1)));
		countMeasure("OBSXYZ");
		break;
 case 743: 
	case 744:
		if (!_contexts.empty())
			_contexts.pop_back();
		break;
 case 745: 
	case 746:
		if (_secondRun && editor())
		{
			int line = -1, pos = -1;
			editor()->lineIndexFromPosition(sym(1).position(), &line, &pos);
			_sigmaLines[line].insert("ACST");
		}
		break;

	case 748: // *RADI sigma_mm
		checkDouble(2, "sigma_mm");
		[[fallthrough]];

	case 749: // *RADI sigma_mm
		addAnnotation(_ANNOTATION_RADI);
		addStyleSym(Styles::MeasureType, 1);
		startFolding();
		_contexts.push_back(Context::MEASURES);
		if (_secondRun && editor())
		{
			int line = -1, pos = -1;
			editor()->lineIndexFromPosition(sym(1).position(), &line, &pos);
		}
		break;

	case 756: // point bearing_gons
		addAnnotation(_ANNOTATION_RADI_POINT);
		addStyleSym(Styles::Normal, 2);

		setMeasure("RADI/" + toTrimmedQString(sym(1)));
		countMeasure("RADI");
		if (_secondRun && editor())
		{
			int line = -1, pos = -1;
			editor()->lineIndexFromPosition(sym(1).position(), &line, &pos);
			_sigmaLines[line].insert("OBSE");
			_sigmaLines[line].insert("ACST");
		}
		break;
 case 763: 
	case 764: // *END *FIN
		_isPostEnd = true;
		_endPos = sym(1).position();
		addStyleSym(Styles::StartEnd, 1);
		break;

	} // of the switch
}

int LGCInputLexerIO::nextToken(QStringRef value)
{
	if(_isPostEnd)
		return LGCInputLexerIO::WORD;

	static const QRegularExpression numericrgx = ([]() -> QRegularExpression {
		QRegularExpression rgx(R"""(^-?[[:digit:]]*\.?[[:digit:]]+$)""");
		rgx.optimize();
		return rgx;
	})();

	QStringRef tval = value.trimmed();
	if (!tval.isEmpty())
	{
		// comment
		if (commentChars().contains(tval[0]))
			return LGCInputLexerIO::COMMENTSTRING;
		// functional comment
		if (tval[0] == _functionalComment)
			return LGCInputLexerIO::DOLLAR;
		// numbers
		if (numericrgx.match(tval).hasMatch())
		{
			bool ok;
			tval.toInt(&ok);
			if (ok)
				return LGCInputLexerIO::INTEGER;
			tval.toDouble(&ok);
			if (ok)
				return LGCInputLexerIO::DECIMAL;
		}
		// keywords / parameters
		const bool ctxt = value.position() != _currentLine.position() && (!_inlineContexts.empty() || (!_contexts.empty() && _contexts.back() == Context::MEASURES));
		if ((value.position() == _currentLine.position() && tval[0] == '*') || ctxt)
		{
			for (int i = 0; i < LGCInputLexerIO::TERMINAL_COUNT; i++)
			{
				if (tval == LGCInputLexerIO::spell[i])
					return i;
			}
			if (ctxt)
				return LGCInputLexerIO::WORD;
			return LGCInputLexerIO::UNKNOWN;
		}
	}

	return LGCInputLexerIO::WORD;
}
